import com.mainstreetsoftworks.MCVE;
class AppDemo {
  private static MCVE conn1 = null;
  private static int identifier=-1;

  private static String username="vitale";
  private static String password="test";
  private static String trackdata="";
  private static String account="4012888888881";
  private static String expdate="0512";
  private static double amount=15.00;
  private static String comments="JAVA";
  private static String street="";
  private static String zip="";
  private static String cv="";
  private static String stationid="";
  private static String clerkid="";
  private static int ptrannum=4321;
  private static String text="";
  private static String authnum="";

  public static void main(String[] args) {
         System.out.println("Authorizing Transaction...");
	 conn1 = new MCVE("");
         conn1.SetIP("testbox.monetra.com", 8333);
	 conn1.SetTimeout(30);  // Max 30 seconds
         if (conn1.Connect() <= 0) {
	   System.out.println("Could not connect to MONETRA!");
	   return;
	 }
         identifier=conn1.Sale(username, password, trackdata, account, expdate, amount, null, zip, cv, comments, clerkid, stationid, ptrannum);
         while (conn1.CheckStatus(identifier) != conn1.MCVE_DONE) {
           conn1.Monitor();
         }
         if (conn1.ReturnStatus(identifier) == conn1.MCVE_SUCCESS) {
           System.out.println("Transaction Authorized");
         } else {
           System.out.println("Transaction Denied");
         }
         if (conn1.ReturnCode(identifier) == conn1.MCVE_AUTH) {
           System.out.println("Code: AUTH");
         } else if (conn1.ReturnCode(identifier) == conn1.MCVE_DENY) {
           System.out.println("Code: DENY");
         } else if (conn1.ReturnCode(identifier) == conn1.MCVE_CALL) {
           System.out.println("Code: CALL");
         } else if (conn1.ReturnCode(identifier) == conn1.MCVE_PKUP) {
           System.out.println("Code: PICKUP");
         } else if (conn1.ReturnCode(identifier) == conn1.MCVE_SUCCESS) {
           System.out.println("Code: Success");
         } else if (conn1.ReturnCode(identifier) == conn1.MCVE_FAIL) {
           System.out.println("Code: Deny");
	 } else if (conn1.ReturnCode(identifier) == conn1.MCVE_TIMEOUT) {
           System.out.println("Code: TIMEOUT");
         } else {
           System.out.println("Code: Other");
         }

         if (conn1.TransactionAVS(identifier) == conn1.MCVE_GOOD) {
           System.out.println("AVS: Good");
	 } else if (conn1.TransactionAVS(identifier) == conn1.MCVE_BAD) {
	   System.out.println("AVS: Bad");
         } else if (conn1.TransactionAVS(identifier) == conn1.MCVE_UNKNOWN) {
	   System.out.println("AVS: Unknown");
	 } else if (conn1.TransactionAVS(identifier) == conn1.MCVE_STREET) {
	   System.out.println("AVS: Street Failed");
	 } else if (conn1.TransactionAVS(identifier) == conn1.MCVE_ZIP) {
	   System.out.println("AVS: Zip Failed");
	 }
	 if (conn1.TransactionCV(identifier) == conn1.MCVE_GOOD) {
           System.out.println("CV: Good");
	 } else if (conn1.TransactionCV(identifier) == conn1.MCVE_BAD) {
	   System.out.println("CV: Bad");
	 } else if (conn1.TransactionCV(identifier) == conn1.MCVE_UNKNOWN) {
	   System.out.println("CV: Unknown");
	 }
         text=conn1.TransactionText(identifier);
         System.out.println("Text: " + text);
	 authnum=conn1.TransactionAuth(identifier);
         if (conn1.ReturnStatus(identifier) == conn1.MCVE_SUCCESS) {
           System.out.println("AuthNum: " + authnum);
         }
	 
	 /* If I knew how to print an int, I'd do it ... */
	 /* this is the transaction "sid" Settlement ID */
	 conn1.TransactionID(identifier);


	 System.out.println("Done");

    }
}
