package com.mainstreetsoftworks;

public class MONETRA {
  static {
    System.loadLibrary("monetrajni");
  }
  private int conn=-1;

  public MONETRA(java.lang.String cafile) {
      conn=M_InitConn(cafile);
  }

  public void finalize() {
      if (conn != -1)
         M_DestroyConn(conn);
  }

  /* Key definitions for Transaction Parameters */
public static final int MC_TRANTYPE =	1;
public static final int MC_USERNAME =	2;
public static final int MC_PASSWORD =	3;
public static final int MC_ACCOUNT =	4;
public static final int MC_TRACKDATA =	5;
public static final int MC_EXPDATE =	6;
public static final int MC_STREET =	7;
public static final int MC_ZIP =	8;
public static final int MC_CV =		9;
public static final int MC_COMMENTS =	10;
public static final int MC_CLERKID =	11;
public static final int MC_STATIONID =	12;
public static final int MC_APPRCODE =	13;
public static final int MC_AMOUNT =	14;
public static final int MC_PTRANNUM =	15;
public static final int MC_TTID =	16;
public static final int MC_USER =	17;
public static final int MC_PWD =	18;
public static final int MC_ACCT =	19;
public static final int MC_BDATE =	20;
public static final int MC_EDATE =	21;
public static final int MC_BATCH =	22;
public static final int MC_FILE =	23;
public static final int MC_ADMIN =	24;
public static final int MC_AUDITTYPE =	25;
public static final int MC_CUSTOM=		26;
/* restaurant, lodging, auto-rental */
public static final int MC_EXAMOUNT=     	27;
public static final int MC_EXCHARGES=    	28;
public static final int MC_RATE=         	29;
public static final int MC_RENTERNAME=   	30;
public static final int MC_RETURNCITY=   	31;
public static final int MC_RETURNSTATE=  	32;
public static final int MC_RETURNLOCATION=       33;
public static final int MC_PRIORITY=		34;
public static final int MC_INQUIRY=		35;

public static final int MC_CARDTYPES=		36;
public static final int MC_SUB=			37;
public static final int MC_MARKER=		38;
public static final int MC_DEVICETYPE=		39;
public static final int MC_ERRORCODE=		40;
public static final int MC_NEWBATCH=		41;
public static final int MC_CURR=		42;
public static final int MC_DESCMERCH=		43;
public static final int MC_DESCLOC=		44;
public static final int MC_ORIGTYPE=		45;
public static final int MC_PIN=			46;
public static final int MC_VOIDORIGTYPE=	47;
public static final int MC_TIMESTAMP=            48;


/* Priorities */
public static final java.lang.String MC_PRIO_HIGH=	"1";
public static final java.lang.String MC_PRIO_NORMAL=	"2";
public static final java.lang.String MC_PRIO_LOW=	"3";


/* Excharges for lodging and auto-rental*/
public static final java.lang.String MC_EXCHARGES_REST=         "1";
public static final java.lang.String MC_EXCHARGES_GIFT=         "2";
public static final java.lang.String MC_EXCHARGES_MINI=         "3";
public static final java.lang.String MC_EXCHARGES_TELE=         "4";
public static final java.lang.String MC_EXCHARGES_OTHER=        "5";
public static final java.lang.String MC_EXCHARGES_LAUND=        "6";
public static final java.lang.String MC_EXCHARGES_NONE=         "7";

public static final java.lang.String MC_EXCHARGES_GAS=          "8";
public static final java.lang.String MC_EXCHARGES_MILE=         "9";
public static final java.lang.String MC_EXCHARGES_LATE=         "10";
public static final java.lang.String MC_EXCHARGES_1WAY=         "11";
public static final java.lang.String MC_EXCHARGES_VIOL=         "12";

/* Args for adding a user */
public static final int MC_USER_PROC=		2000;
public static final int MC_USER_USER=		2001;
public static final int MC_USER_PWD=		2002;
public static final int MC_USER_INDCODE=	2003;
public static final int MC_USER_MERCHID=	2004;
public static final int MC_USER_BANKID=		2005;
public static final int MC_USER_TERMID=		2006;
public static final int MC_USER_CLIENTNUM=	2007;
public static final int MC_USER_STOREID=	2008;
public static final int MC_USER_AGENTID=	2009;
public static final int MC_USER_CHAINID=	2010;
public static final int MC_USER_ZIPCODE=	2011;
public static final int MC_USER_TIMEZONE=	2012;
public static final int MC_USER_MERCHCAT=	2013;
public static final int MC_USER_MERNAME=	2014;
public static final int MC_USER_MERCHLOC=	2015;
public static final int MC_USER_STATECODE=	2016;
public static final int MC_USER_PHONE=		2017;
public static final int MC_USER_SUB=		2018;
public static final int MC_USER_CARDTYPES=	2019;
public static final int MC_USER_MODE=		2020;
public static final int MC_USER_VNUMBER=	2021;
public static final int MC_USER_ROUTINGID=	2022;
public static final int MC_USER_PPROPERTY=	2023;
public static final int MC_USER_PID=		2024;
public static final int MC_USER_PIDPWD=		2025;
public static final int MC_USER_SMID=		2026;
public static final int MC_USER_SMIDPWD=	2027;
public static final int MC_USER_USDDIV=		2028;
public static final int MC_USER_AUDDIV=		2029;
public static final int MC_USER_DKKDIV=		2030;
public static final int MC_USER_GBPDIV=		2031;
public static final int MC_USER_HKDDIV=		2032;
public static final int MC_USER_JPYDIV=		2033;
public static final int MC_USER_NZDDIV=		2034;
public static final int MC_USER_NOKDIV=		2035;
public static final int MC_USER_SGDDIV=		2036;
public static final int MC_USER_ZARDIV=		2037;
public static final int MC_USER_SEKDIV=		2038;
public static final int MC_USER_CHFDIV=		2039;
public static final int MC_USER_CADDIV=		2040;
public static final int MC_USER_DIVNUM=         2041;

/* Value definitions for Transaction Types */
public static final java.lang.String MC_TRAN_SALE="1";
public static final java.lang.String MC_TRAN_REDEMPTION=MC_TRAN_SALE;
public static final java.lang.String MC_TRAN_PREAUTH="2";
public static final java.lang.String MC_TRAN_VOID="3";
public static final java.lang.String MC_TRAN_PREAUTHCOMPLETE="4";
public static final java.lang.String MC_TRAN_FORCE="5";
public static final java.lang.String MC_TRAN_OVERRIDE="6";
public static final java.lang.String MC_TRAN_RETURN="7";
public static final java.lang.String MC_TRAN_RELOAD=MC_TRAN_RETURN;
public static final java.lang.String MC_TRAN_CREDIT=MC_TRAN_RETURN;
public static final java.lang.String MC_TRAN_SETTLE="8";
public static final java.lang.String MC_TRAN_INCREMENTAL="9";
public static final java.lang.String MC_TRAN_REVERSAL="10";
public static final java.lang.String MC_TRAN_ACTIVATE="11";
public static final java.lang.String MC_TRAN_BALANCEINQ="12";
public static final java.lang.String MC_TRAN_CASHOUT="13";
public static final java.lang.String MC_TRAN_TOREVERSAL="14";
public static final java.lang.String MC_TRAN_SETTLERFR="15";
public static final java.lang.String MC_TRAN_ISSUE="16";
public static final java.lang.String MC_TRAN_TIP="17";
public static final java.lang.String MC_TRAN_MERCHRETURN="18";
public static final java.lang.String MC_TRAN_IVRREQ="19";
public static final java.lang.String MC_TRAN_IVRRESP="20";
public static final java.lang.String MC_TRAN_ADMIN="50";
public static final java.lang.String MC_TRAN_PING="100";
public static final java.lang.String MC_TRAN_CHKPWD="200";

/* Engine Admin Transaction Types */
public static final java.lang.String MC_TRAN_CHNGPWD="1001";
public static final java.lang.String MC_TRAN_LISTSTATS="1002";
public static final java.lang.String MC_TRAN_LISTUSERS="1003";
public static final java.lang.String MC_TRAN_GETUSERINFO="1004";
public static final java.lang.String MC_TRAN_ADDUSER="1005";
public static final java.lang.String MC_TRAN_EDITUSER="1006";
public static final java.lang.String MC_TRAN_DELUSER="1007";
public static final java.lang.String MC_TRAN_ENABLEUSER="1008";
public static final java.lang.String MC_TRAN_DISABLEUSER="1009";
public static final java.lang.String MC_TRAN_IMPORT="1010";
public static final java.lang.String MC_TRAN_EXPORT="1011";
public static final java.lang.String MC_TRAN_ERRORLOG="1012";
public static final java.lang.String MC_TRAN_CLEARERRORLOG="1013";
public static final java.lang.String MC_TRAN_GETSUBACCTS="1014";



/* Value definitions for Admin Types */
public static final java.lang.String MC_ADMIN_GUT="1";
public static final java.lang.String MC_ADMIN_GL="2";
public static final java.lang.String MC_ADMIN_GFT="3";
public static final java.lang.String MC_ADMIN_BT="4";
public static final java.lang.String MC_ADMIN_UB=MC_ADMIN_BT;
public static final java.lang.String MC_ADMIN_QC="5";
public static final java.lang.String MC_ADMIN_RS="6";
public static final java.lang.String MC_ADMIN_CTH="7";
public static final java.lang.String MC_ADMIN_CFH="8";
public static final java.lang.String MC_ADMIN_FORCESETTLE="9";
public static final java.lang.String MC_ADMIN_SETBATCHNUM="10";
public static final java.lang.String MC_ADMIN_RENUMBERBATCH="11";
public static final java.lang.String MC_ADMIN_FIELDEDIT="12";
public static final java.lang.String MC_ADMIN_CLOSEBATCH="13";

  /* Response Codes */
  public static final int MCVE_ERROR = -1;
  public static final int MCVE_FAIL = 0;
  public static final int MCVE_SUCCESS = 1;

  public static final int MCVE_UNUSED = 0;
  public static final int MCVE_NEW = 100;
  public static final int MCVE_PENDING = 1;
  public static final int MCVE_DONE = 2;
  public static final int MCVE_AUTH = 2;
  public static final int MCVE_DENY = 3;
  public static final int MCVE_CALL = 4;
  public static final int MCVE_DUPL = 5;
  public static final int MCVE_PKUP = 6;
  public static final int MCVE_RETRY = 7;
  public static final int MCVE_SETUP = 8;
  public static final int MCVE_TIMEOUT = 9;

  /* AVS & CV Response Codes */
  public static final int MCVE_GOOD = 1;
  public static final int MCVE_BAD = 0;
  public static final int MCVE_UNKNOWN = -1;

  /* AVS only response codes */
  public static final int MCVE_STREET = 2;
  public static final int MCVE_ZIP = 3;


  /* Transaction types for auditing */
  public static final int MCVE_SALE = 1;
  public static final int MCVE_PREAUTH = 2;
  public static final int MCVE_FORCE = 3;
  public static final int MCVE_OVERRIDE = 4;
  public static final int MCVE_RETURN = 5;
  public static final int MCVE_VOID = 6;
  public static final int MCVE_SETTLE = 8;

  private native int M_InitConn(java.lang.String  cafile);
  private native void M_DestroyConn(int conn);


  private native int M_TransNew(int conn);
  public synchronized int TransNew()
  {
    return(M_TransNew(conn));
  }

  private native int M_TransParam(int conn, int identifier, int key, java.lang.String value);
  public int TransParam(int identifier, int key, java.lang.String value)
  {
    return(M_TransParam(conn, identifier, key, value));
  }

  private native int M_CustomTransParam(int conn, int identifier, java.lang.String key, java.lang.String value);
  public int CustomTransParam(int identifier, java.lang.String key, java.lang.String value)
  {
    return(M_CustomTransParam(conn, identifier, key, value));
  }

  private native int M_TransSend(int conn, int identifier);
  public synchronized int TransSend(int identifier)
  {
    return(M_TransSend(conn, identifier));
  }


  private native java.lang.String M_ResponseParam(int conn, int identifier, java.lang.String key);
  public java.lang.String ResponseParam(int identifier, java.lang.String key)
  {
    return(M_ResponseParam(conn, identifier, key));
  }


  private native void M_DeleteResponse(int conn, int identifier);
  public synchronized void DeleteResponse(int identifier)
  {
    M_DeleteResponse(conn, identifier);
  }

  private native int M_SetDropFile(int conn, java.lang.String df_location);
  public int SetDropFile(java.lang.String df_location)
  {
    return(M_SetDropFile(conn, df_location));
  }

  private native int M_SetIP(int conn, java.lang.String  host, int port);
  public int SetIP(java.lang.String host, int port)
  {
    return(M_SetIP(conn, host, port));
  }

  private native int M_SetSSL(int conn, java.lang.String  host, int port);
  public int SetSSL(java.lang.String host, int port)
  {
    return(M_SetSSL(conn, host, port));
  }

  private native int M_Connect(int conn);
  public synchronized int Connect()
  {
    return(M_Connect(conn));
  }

  private native int M_SetTimeout(int conn, int secs);
  public synchronized int SetTimeout(int secs)
  {
    return(M_SetTimeout(conn, secs));
  }
  
  private native int M_SetBlocking(int conn, int tf);
  public synchronized int SetBlocking(int tf)
  {
    return(M_SetBlocking(conn, tf));
  }

  private native int M_Monitor(int conn);
  public synchronized int Monitor()
  {
    return(M_Monitor(conn));
  }

  private native int M_TransactionsSent(int conn);
  public int TransactionsSent()
  {
    return(M_TransactionsSent(conn));
  }

// Transaction Routines
  private native int M_Sale(int conn, java.lang.String username, java.lang.String password, java.lang.String trackdata, java.lang.String account, java.lang.String expdate, double amount,
                               java.lang.String street, java.lang.String zip, java.lang.String cv, java.lang.String comments, java.lang.String clerkid, java.lang.String stationid, int ptrannum);
  public synchronized int Sale(java.lang.String username, java.lang.String password, java.lang.String trackdata, java.lang.String account, java.lang.String expdate, double amount,
                               java.lang.String street, java.lang.String zip, java.lang.String cv, java.lang.String comments, java.lang.String clerkid, java.lang.String stationid, int ptrannum)
  {
    return(M_Sale(conn, username, password, trackdata, account, expdate, amount, street, zip, cv, comments, clerkid, stationid, ptrannum));
  }

  private native int M_PreAuth(int conn, java.lang.String username, java.lang.String password, java.lang.String trackdata, java.lang.String account, java.lang.String expdate, double amount,
                                     java.lang.String street, java.lang.String zip, java.lang.String cv, java.lang.String comments, java.lang.String clerkid, java.lang.String stationid, int ptrannum);
  public synchronized int PreAuth(java.lang.String username, java.lang.String password, java.lang.String trackdata, java.lang.String account, java.lang.String expdate, double amount,
                               java.lang.String street, java.lang.String zip, java.lang.String cv, java.lang.String comments, java.lang.String clerkid, java.lang.String stationid, int ptrannum)
  {
    return(M_PreAuth(conn, username, password, trackdata, account, expdate, amount, street, zip, cv, comments, clerkid, stationid, ptrannum));
  }

  private native int M_Void(int conn, java.lang.String username, java.lang.String password, int sid, int ptrannum);
  public synchronized int Void(java.lang.String username, java.lang.String password, int sid, int ptrannum)
  {
    return(M_Void(conn, username, password, sid, ptrannum));
  }

  private native int M_PreAuthCompletion(int conn, java.lang.String username, java.lang.String password, double finalamount, int sid, int ptrannum);
  public synchronized int PreAuthCompletion(java.lang.String username, java.lang.String password, double finalamount, int sid, int ptrannum)
  {
    return(M_PreAuthCompletion(conn, username, password, finalamount, sid, ptrannum));
  }

  private native int M_Force(int conn, java.lang.String username, java.lang.String password, java.lang.String trackdata, java.lang.String account, java.lang.String expdate, double amount,
                java.lang.String authcode, java.lang.String comments, java.lang.String clerkid, java.lang.String stationid, int ptrannum);
  public synchronized int Force(java.lang.String username, java.lang.String password, java.lang.String trackdata, java.lang.String account, java.lang.String expdate, double amount,
                               java.lang.String authcode, java.lang.String comments, java.lang.String clerkid, java.lang.String stationid, int ptrannum)
  {
    return(M_Force(conn, username, password, trackdata, account, expdate, amount, authcode, comments, clerkid, stationid, ptrannum));
  }


  private native int M_Return(int conn, java.lang.String username, java.lang.String password, java.lang.String trackdata, java.lang.String account, java.lang.String expdate, double amount,
                                     java.lang.String comments, java.lang.String clerkid, java.lang.String stationid, int ptrannum);
  public synchronized int Return( java.lang.String username, java.lang.String password, java.lang.String trackdata, java.lang.String account, java.lang.String expdate, double amount,
                                     java.lang.String comments, java.lang.String clerkid, java.lang.String stationid, int ptrannum)
  {
    return(M_Return(conn, username, password, trackdata, account, expdate, amount, comments, clerkid, stationid, ptrannum));
  }

  private native int M_Override(int conn, java.lang.String username, java.lang.String password, java.lang.String trackdata, java.lang.String account, java.lang.String expdate, double amount,
                                     java.lang.String street, java.lang.String zip, java.lang.String cv, java.lang.String comments, java.lang.String clerkid, java.lang.String stationid, int ptrannum);
  public synchronized int Override(java.lang.String username, java.lang.String password, java.lang.String trackdata, java.lang.String account, java.lang.String expdate, double amount,
                                     java.lang.String street, java.lang.String zip, java.lang.String cv, java.lang.String comments, java.lang.String clerkid, java.lang.String stationid, int ptrannum)
  {
    return(M_Override(conn, username, password, trackdata, account, expdate, amount, street, zip, cv, comments, clerkid, stationid, ptrannum));
  }


  private native int M_Settle(int conn, java.lang.String username, java.lang.String password, java.lang.String batch);
  public synchronized int Settle(java.lang.String username, java.lang.String password, java.lang.String batch)
  {
    return(M_Settle(conn, username, password, batch));
  }


// Response Checking Routines
  private native int M_ReturnStatus(int conn, int identifier);
  public int ReturnStatus(int identifier)
  {
    return(M_ReturnStatus(conn, identifier));
  }

  private native int M_ReturnCode(int conn, int identifier);
  public int ReturnCode(int identifier)
  {
    return(M_ReturnCode(conn, identifier));
  }

  private native int M_TransactionItem(int conn, int identifier);
  public int TransactionItem(int identifier)
  {
    return(M_TransactionItem(conn, identifier));
  }

  private native int M_TransactionBatch(int conn, int identifier);
  public int TransactionBatch(int identifier)
  {
    return(M_TransactionBatch(conn, identifier));
  }

  private native int M_TransactionID(int conn, int identifier);
  public int TransactionID(int identifier)
  {
    return(M_TransactionID(conn, identifier));
  }

  private native int M_TransactionAVS(int conn, int identifier);
  public int TransactionAVS(int identifier)
  {
    return(M_TransactionAVS(conn, identifier));
  }

  private native int M_TransactionCV(int conn, int identifier);
  public int TransactionCV(int identifier)
  {
    return(M_TransactionCV(conn, identifier));
  }

  private native java.lang.String M_TransactionAuth(int conn, int identifier);
  public  java.lang.String TransactionAuth(int identifier)
  {
    return(M_TransactionAuth(conn, identifier));
  }

  private native java.lang.String M_TransactionText(int conn, int identifier);
  public java.lang.String TransactionText(int identifier)
  {
    return(M_TransactionText(conn, identifier));
  }

  private native int M_TransInQueue(int conn);
  public synchronized int TransInQueue()
  {
    return(M_TransInQueue(conn));
  }

  private native int M_CheckStatus(int conn, int trans);
  public synchronized int CheckStatus(int trans)
  {
    return(M_CheckStatus(conn, trans));
  }
  
  
  private native int M_Ub(int conn, java.lang.String musername, java.lang.String mpassword);
  public synchronized int Ub(java.lang.String username, java.lang.String password)
  {
    return(M_Ub(conn, username, password));
  }

  private native int M_Bt(int conn, java.lang.String musername, java.lang.String mpassword);
  public synchronized int Bt(java.lang.String username, java.lang.String password)
  {
    return(M_Bt(conn, username, password));
  }

  private native int M_Gft(int conn, java.lang.String musername, java.lang.String mpassword, int type, java.lang.String macct, java.lang.String mclerkid, java.lang.String mstationid, java.lang.String mcomments, double ptrannum, java.lang.String mbdate, java.lang.String medate);
  public synchronized int Gft(java.lang.String username, java.lang.String password, int type, java.lang.String acct, java.lang.String clerkid, java.lang.String stationid, java.lang.String comments, double ptrannum, java.lang.String bdate, java.lang.String

 edate)
  {
    return(M_Gft(conn, username, password, type, acct, clerkid, stationid, comments, ptrannum, bdate, edate));
  }


  private native int M_Gl(int conn, java.lang.String musername, java.lang.String mpassword, int type, java.lang.String macct, java.lang.String mbatch, java.lang.String mclerkid, java.lang.String mstationid, java.lang.String mcomments, double ptrannum, java.lang.String mbdate, java.lang.String medate);
  public synchronized int Gl(java.lang.String username, java.lang.String password, int type, java.lang.String acct, java.lang.String batch, java.lang.String clerkid, java.lang.String stationid, java.lang.String comments, double ptrannum, java.lang.String bdate, java.lang.String edate)
  {
    return(M_Gl(conn, username, password, type, acct, batch, clerkid, stationid, comments, ptrannum, bdate, edate));
  }

  private native int M_Gut(int conn, java.lang.String musername, java.lang.String mpassword, int type, java.lang.String macct, java.lang.String mclerkid, java.lang.String mstationid, java.lang.String comments, double ptrannum, java.lang.String mbdate, java.lang.String medate);
  public synchronized int Gut(java.lang.String username, java.lang.String password, int type, java.lang.String acct, java.lang.String clerkid, java.lang.String stationid, java.lang.String comments, double ptrannum, java.lang.String bdate, java.lang.String edate)
  {
    return(M_Gut(conn, username, password, type, acct, clerkid, stationid, comments, ptrannum, bdate, edate));
  }


  private native int M_IsCommaDelimited(int conn, int identifier);
  public int IsCommaDelimited(int identifier)
  {
    return(M_IsCommaDelimited(conn, identifier));
  }

  private native int M_ParseCommaDelimited(int conn, int identifier);
  public synchronized int ParseCommaDelimited(int identifier)
  {
    return(M_ParseCommaDelimited(conn, identifier));
  }

  private native java.lang.String M_GetCommaDelimited(int conn, int identifier);
  public java.lang.String GetCommaDelimited(int identifier)
  {
    return(M_GetCommaDelimited(conn, identifier));
  }

  private native java.lang.String M_GetCell(int conn, int identifier, java.lang.String column, int row);
  public java.lang.String GetCell(int identifier, java.lang.String column, int row)
  {
    return(M_GetCell(conn, identifier, column, row));
  }

  private native java.lang.String M_GetCellByNum(int conn, int identifier, int column, int row);
  public java.lang.String GetCellByNum(int identifier, int column, int row)
  {
    return(M_GetCellByNum(conn, identifier, column, row));
  }


  private native int M_NumColumns(int conn, int identifier);
  public int NumColumns(int identifier)
  {
    return(M_NumColumns(conn, identifier));
  }

  private native int M_NumRows(int conn, int identifier);
  public int NumRows(int identifier)
  {
    return(M_NumRows(conn, identifier));
  }

  private native java.lang.String M_GetHeader(int conn, int identifier, int column_num);
  public java.lang.String GetHeader(int identifier, int column_num)
  {
    return(M_GetHeader(conn, identifier, column_num));
  }

  private native java.lang.String M_TEXT_Code(int code);
  public java.lang.String TEXT_Code(int code)
  {
    return(M_TEXT_Code(code));
  }
  
  private native java.lang.String M_TEXT_AVS(int code);
  public java.lang.String TEXT_AVS(int code)
  {
    return(M_TEXT_AVS(code));
  }

  private native java.lang.String M_TEXT_CV(int code);
  public java.lang.String TEXT_CV(int code)
  {
    return(M_TEXT_CV(code));
  }
  

}

